# CarController

---

基于NodeMcu开发的ESP8266智能小车控制器，接入SSD1306作为配网以及服务显示功能，后续会增加更多功能

# 1.准备工作🧐

---

## 1.1设备清单

`数据线等烧录用不在此列`

| 设备名称        | 数量     | 设备型号                  |
| ----------- | ------ | --------------------- |
| ESP8266     | 1      | ESP-12F，其他ESP8266可用型号 |
| led灯珠       | 4-5个   | 3v3最低耐压               |
| 电线          | 12-16条 | 常用杜邦线或者其他相似参数         |
| I2C协议OLED屏幕 | 1      | SSD1306_12864_noname  |
| USB供电（可选）   | 1      | 3.3v引脚供电&5VUSB供电      |

## 1.2固件烧录

先从该连接，下载 Flash下载工具(flash_download_tool_3.9.5_0.zip)，如果有新版本可能名称会有所不同。

  [工具 | 乐鑫科技 ](https://www.espressif.com.cn/zh-hans/support/download/other-tools)

下载完之后，将工程下的flash_download_tool_3.9.5.exe打开
![](DocRes\1_1.jpg)

选择ESP8266

![](DocRes\1_2.jpg)

进入如下界面，点击第一项，选择工程下 Firmware里对应的固件文件，由于程序使用的固件版本为float，但未曾写过使用float类型的程序。int没有测试过，保险起见可以选择float版本，右边填0。选择如下所示，串口检测到后点击对应的串口进行烧录即可。

![](DocRes/1_0.jpg)

烧录的波特率默认为115200，运行以及开发用的波特率同理。

## 1.3程序烧录

首先去github上下载ESPlorer，右侧release可以下载最新的发布版本，可能需要翻墙。

[ESPlorer](https://github.com/4refr0nt/ESPlorer)

下载完成后运行ESPlorer.bat，即可打开该开发工具，然后打开工程的所有lua文件并保存到ESP8266中。目前还处于手动配置网络的阶段，后续会继续优化该配网功能。

拷贝 **Src** 文件夹下的所有脚本文件到ESP8266中。

![](DocRes/InstallSoft.png)

# 2.接线说明🔌

---

NodeMCU开发板引脚图

![](DocRes/NodeMcu_Pinout.webp)

## 2.1 GPIO-LED接线说明

GPIO控制D0-D2，一共三路GPIO供电开关，引出脚需要接入二极管以防止干扰其他控制器工作。

| 接线方式 | LED引脚 | ESP8266引脚 |
| ---- | ----- | --------- |
| 直连   | 负极    | GND       |
| 直连   | 正极    | D0        |
| 直连   | 正极    | D1        |
| 直连   | 正极    | D2        |

## 2.2 SSD1306-12864-I2C接线说明

oled显示屏用于显示配网参数以及连接状态，指示灯状态等信息，方便更快找到设备故障原因。

| 接线方式 | SSD1306-12864-I2C引脚 | ESP8266引脚 |
| ---- | ------------------- | --------- |
| 直连   | GND                 | GND       |
| 直连   | VCC                 | 3v        |
| 直连   | SCL                 | D5        |
| 直连   | SDA                 | D6        |

`如有其他设备需要接线后续补充`

# 3.串口软件网络设置⚙

---

串口配网软件下载地址[点击下载](http://124.222.119.133:5212/s/BrU0)
提取码：Node 

打开串口软件，NodeMCUSerialTools文件夹下面的NetTools.exe。

以下操作开始之前，请先按照第一步烧录完固件与软件。

ESP8266开发板（需带ch340或cp201x芯片）+数据线与PC进行链接。

或者使用ESP8266+CH340等串口连接设备与PC进行链接

（TX-RX，RX-TX）

![](DocRes/1_3.jpg)

## 3.1选择串口

如果是连接之前打开，可以先检查右下角COM串口列表，连接设备后点击刷新，可以看到新的串口设备在列表中新增。

点击右下角以刷新或者是切换串口设备。

## 3.2设置WiFi连接信息

选项说明

| 名称     | 含义              |
| ------ | --------------- |
| SSID名称 | 手机扫描热点显示的WiFi名称 |
| 密码     | 该热点的WiFi密码      |

写入配网信息

等待2-3秒后，软件会通过串口写入WiFi连接的信息。

如果是首次配网，会自动连接网络。

如果是第二次配网，需要重启并验证网络。

## 3.3设置设备的IP地址

![](DocRes/1_4.png)

选项说明

| 名称   | 含义                                                                                      |
| ---- | --------------------------------------------------------------------------------------- |
| IP地址 | 跟据平板的网段ip地址，配置好对应网段的地址（如：平板IP地址：192.168.6.15，则该地址只能配置为192.168.6.x，x为2-255之间除了15的任意一个数字） |
| 子网掩码 | 255.255.255.0（默认值，一般不需要修改）                                                              |
| 默认网关 | 如果平板网段地址为192.168.6.15，一般情况下网关为192.168.6.1，可以用电脑的cmd->ipconfig来查看相应的网关地址。                |

# 4.通讯协议📡

该设备使用UDP作为通讯协议，UDP地址为上面配置的ip地址，端口号默认为6000。

https://www.processon.com/view/link/67407595a1c0ad5bcd730768?cid=6740188e59efb87d34212ad8 访问密码：6KYl

# 5.安卓控制软件Demo使用说明🎮

该控制器配备相应的控制软件，需要安装到平板上使用。

[平板端V3下载地址](http://124.222.119.133:5212/s/Qkup)

首次发布版本。

[平板端V3_1下载地址](http://124.222.119.133:5212/s/vOI1)

更新日志：新增了智能车按IP地址编号，并且根据编号进行排序的功能

[平板端V3_2下载地址](http://124.222.119.133:5212/s/Nlsw)

更新日志：新增默认会产生重复控制单元的bug修复

![](DocRes/pad1.jpg)

## 扫描

单次扫描在内网下的所有智能小车，需要提前配置好WiFi热点及其密码，IP地址。

如果没有任何智能小车被扫描出来，请重复点击扫描按钮直到扫描出来为止。

## 新增默认

如果扫描功能不可用，新增默认地址192.168.1.241~248这个IP的智能车。

---

## 指示灯说明

| 名称  | 控制器引脚 | 说明                     |
| --- | ----- | ---------------------- |
| 信号  | D0    | 信号启动时，小车为启动状态          |
| 倒车  | D1    | 倒车信号高亮时前进，倒车信号非高亮状态时倒退 |
| 刹车  | D2    | 刹车非高亮时，刹车为启动状态         |

## 指令说明

`点击`为一次按下抬起动作。

- `前进`按钮点击时，小车置为前进状态。

- `后退`按钮点击时，小车置为后退状态。

- `刹车`按钮点击时，小车置为停止状态。

- `点进`按钮按下时，小车置为前进状态。按钮抬起时，小车置为停止状态

- `点退`按钮按下时，小车置为后退状态。按钮抬起时，小车置为停止状态

# QA

---

- 为什么我不管按前进还是后退，状态都正常显示，但车一直在后退？

> 因为小车处于倒车状态，产生这样的原因是使用遥控器进行了倒车行为，两者都使用的情况下，倒车信号会产生冲突。
> 
> 请使用遥控器进行点进，或者前进，然后停止。使小车处于前进状态，此时使用平板再控制就正常了。

---

- 为什么我扫描不到智能车？

> 请尝试多点击几次，或者检查网络配置是否正确，ap信号是否覆盖，天线连接是否正常。
> 
> 如果实在扫描不到，请将IP改为192.168.1.241-248中的其中一个，并使用新增默认按钮添加后尝试是否能够控制。

---

- 控制信号为什么会隔一段时间才收到？

> 因为小车的通讯方式是基于UDP，存在丢包的可能性，如果没有收到控制板返回的消息，则每隔1s会进行重发控制消息直至收到回复的状态为止。
> 
> 如果期间进行了多次操作仍未返回消息，重发的数据为最后一次的控制命令。

---

- 小车失控时我该怎么做？

> 别慌张，前方有急停按钮，按下后会立即断电并停止控制行为。
